import { path } from "ramda";
import { toBoolean } from "./to-boolean";
import * as dotEnv from "dotenv";

dotEnv.config();

export const environment = {
  APP_BASE_URL: process.env.APP_BASE_URL,
  NODE_ENV: process.env.NODE_ENV,
  USE_UNSECURE_COOKIE: path(["env", "USE_UNSECURE_COOKIE"], process) === "true",
  DATADOG_APM_ENABLED: path(["env", "DATADOG_APM_ENABLED"], process) === "true",
  DATADOG_HOST_URL: process.env.DATADOG_HOST_URL,
  GA_TRACKING_ID: process.env.GA_TRACKING_ID,
  LOG_LEVEL: process.env.LOG_LEVEL || "debug",
  LOGGING_FILE_NAME: process.env.LOGGING_FILE_NAME || "application-%DATE%.log",
  LOGGING_FILE_MAX_SIZE: process.env.LOGGING_FILE_MAX_SIZE || "50m",
  LOGGING_FILE_MAX_FILES: process.env.LOGGING_FILE_MAX_FILES || "28d",
  MAINTENANCE_MODE: toBoolean(process.env.MAINTENANCE_MODE) || toBoolean(false),
  SERVICE_AVAILABLE_DATE: process.env.SERVICE_AVAILABLE_DATE,
  OVERVIEW_URL: "/",
  APP_VERSION: process.env.APP_VERSION || "unknown",
  GOOGLE_ANALYTICS_URI: process.env.GOOGLE_ANALYTICS_URI,
  CONTACT_PREFERENCE: process.env.CONTACT_PREFERENCE,
  CONTACT_TELEPHONE: process.env.CONTACT_TELEPHONE,
  CONTACT_EMAIL: process.env.CONTACT_EMAIL,
  HRT_PPC_VALUE: undefined,
  HRT_PPC_VALUE_UPDATE_TIME: undefined,
  PRESCRIPTION_VALUE: process.env.PRESCRIPTION_VALUE,
  OS_PLACES_API_KEY: process.env.OS_PLACES_API_KEY,
  OS_PLACES_URI: process.env.OS_PLACES_URI,
  OUTBOUND_API_TIMEOUT: process.env.OUTBOUND_API_TIMEOUT,
  PRODUCT_API_URI: process.env.PRODUCT_API_URI,
  PRODUCT_API_KEY: process.env.PRODUCT_API_KEY,
  SEARCH_API_URI: process.env.SEARCH_API_URI,
  SEARCH_API_KEY: process.env.SEARCH_API_KEY,
  EXPIRING_EXEMPTION_GRACE_PERIOD:
    process.env.EXPIRING_EXEMPTION_GRACE_PERIOD || 1,
  ISSUE_CERTIFICATE_API_URI: process.env.ISSUE_CERTIFICATE_API_URI,
  ISSUE_CERTIFICATE_API_KEY: process.env.ISSUE_CERTIFICATE_API_KEY,
  COMMON_PDF_API_URI: process.env.COMMON_PDF_API_URI,
  COMMON_PDF_API_KEY: process.env.COMMON_PDF_API_KEY,
  PAYMENT_API_URI: process.env.PAYMENT_API_URI,
  PAYMENT_API_KEY: process.env.PAYMENT_API_KEY,
  CARD_PAYMENTS_API_URI: process.env.CARD_PAYMENTS_API_URI,
  CARD_PAYMENTS_JWT_SECRET: process.env.CARD_PAYMENTS_JWT_SECRET,
  CARD_PAYMENTS_SERVICE_NAME: process.env.CARD_PAYMENTS_SERVICE_NAME,
  CARD_PAYMENTS_USE_MOCK:
    toBoolean(process.env.CARD_PAYMENTS_USE_MOCK) || toBoolean(false),
  LOG_REQUESTS_AND_RESPONSES:
    toBoolean(process.env.LOG_REQUESTS_AND_RESPONSES) || toBoolean(false),
  SESSION_TIMEOUT_MINUTES: process.env.SESSION_TIMEOUT_MINUTES || 30,
  TIMEOUT_WARNING_MINUTES: process.env.TIMEOUT_WARNING_MINUTES || 5,
};
